.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include DlgMain.inc

.code

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax

    invoke InitCommonControls

	invoke DialogBoxParam,hInstance,IDD_DIALOG,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

;########################################################################

DlgProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL hPopPt:POINT
LOCAL lvi:LV_ITEM 
	.if uMsg==WM_INITDIALOG
        invoke GetDlgItem,hWnd,IDC_LIST
	       mov hList,eax
	    invoke LvInsertHeader,eax
	      ; Get the Column Header control & Subclass it.
        invoke GetWindow,hList,GW_CHILD
        ;invoke SetWindowLong,eax,GWL_WNDPROC,ADDR LvDoHeader
        ;   mov hListOldProc,eax

        invoke CreatePopupMenu
           mov hPopMenu, eax     
        invoke AppendMenu, hPopMenu, MF_STRING, IDC_GET, CTEXT("Restart")

        invoke LvAddItem,hList,CTEXT ("Item1"),CTEXT ("Item2")
        invoke LvAddItem,hList,CTEXT ("Item3"),CTEXT ("Item4")
        invoke LvAddItem,hList,CTEXT ("Item5"),CTEXT ("Item6")
        invoke LvAddItem,hList,CTEXT ("Item7"),CTEXT ("Item8")
        invoke LvAddItem,hList,CTEXT ("Item9"),CTEXT ("Item10")
        invoke LvAddItem,hList,CTEXT ("Item10"),CTEXT ("Item11")
        invoke LvAddItem,hList,CTEXT ("Item12"),CTEXT ("Item13")
        invoke LvAddItem,hList,CTEXT ("Item14"),CTEXT ("Item15")

	.elseif uMsg==WM_COMMAND
         .if wParam ==IDC_GET
             invoke SendMessage,hList,LVM_GETNEXTITEM,-1, LVNI_FOCUSED
                inc eax  
	         invoke StatusProgress,hList,eax ,100
         .endif

    .elseif	uMsg == WM_NOTIFY
		     mov eax,lParam
		  assume eax:ptr NMHDR
		.if	[eax].idFrom == IDC_LIST && [eax].code == NM_RCLICK
			      invoke GetCursorPos,addr hPopPt
			      invoke TrackPopupMenu,hPopMenu,TPM_LEFTALIGN,hPopPt.x,hPopPt.y,NULL,hWnd,NULL
		.endif
		  assume eax:nothing

	.elseif uMsg==WM_CLOSE
	@exit:

		invoke EndDialog,hWnd,0
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp

StatusProgress PROC hWnd:DWORD,Id:DWORD,Range:DWORD
    mov eax,1000
	mov CurrentStep,eax
	shl eax,16 
 invoke SendDlgItemMessage,hWnd,Id,PBM_SETRANGE,0,eax
 invoke SendDlgItemMessage,hWnd,Id,PBM_SETSTEP,10,0
 invoke SendDlgItemMessage,hWnd,Id, PBM_SETPOS,Range,0
    ret
StatusProgress endp

end start
